--------------------------------------------------
-- SaveImage.lua
-- 	2014/11/08 - 2014/11/08
-- 					hksy
--------------------------------------------------

function GetDigits(num)
	if(type(num)~="number")then	return nil end
	local d=1
	while(num>10)do
		d	= d+1
		num	= num*0.1
	end
	return	d
end

function SetFileName( str, ext, option )
	if(ext~=nil)then	-- gq
		dot	= string.find( ext, ".",1,true )
		if(dot~=1)then	ext	= "." .. ext	end
	else	ext	= ""	end
	if(string.find( str, ext,1,true )~=nil)then
		ext	= ""
	end

	local find	= string.find
	local sub	= string.sub
	local slen	= string.len

	local s,e	= 1,slen(str)
	local bs	= s-1
	local f
	local t		= {}
	local i		= 1
	local len	= 0
	local path	= ""

	while(s<=e)do
		s	= find(str, "%",s,true)
		if(s==nil)then	break	end

		path	= path.. sub(str,bs,s-1)

		len	= ""
		while(s<=e)do
			f	= sub( str, s+1, s+1)
			if(tonumber(f)==nil)then	break
			else				len	= len .. f
			end

			s	= s+1
		end

		if(len==nil)then	len	= "" end

		local function formatnum(num)
			if(slen(len)==0)then
				len	= "0"..GetDigits(obj.totalframe)
			end

			path	= path .. "%"..len.."d"
			t[i]	= num
			i	= i+1
			s	= s+1
		end

		if	(f=="f")then	-- frame
			formatnum(obj.frame)
		elseif	(f=="i")then	-- ID
			formatnum(option.id)
		end

		s	= s+1
		bs	= s
	end

	path	= path .. sub(str,bs+1)

	file	= string.format(path, unpack(t)) .. ext
	return file
end
