--------------------------------------------------
-- hkBlend.lua
--   썇[hgpdofile()ŌĂяo
--   ɂ点Ă
--   hkmod.dll𓯊KwɒuĎgpĂ
--------------------------------------------------

require("hkmod")

function init_hkBlend()
	local function rotsize(w,h,r)
		local abs = math.abs
		local sin = math.sin(math.rad(r))
		local cos = math.cos(math.rad(r))
		local rw = abs(sin * h) + abs(cos * w)
		local rh = abs(sin * w) + abs(cos * h)
		return rw,rh
	end

	local floor	= math.floor

	local x		= obj.x + obj.ox
	local y		= obj.y + obj.oy
	local z		= obj.z + obj.oz
	local zoom	=obj.getvalue("zoom")/100
	local alpha	= obj.alpha
	local rz	= obj.rz

	local w,h	= obj.getpixel()
	w,h		= rotsize(w*zoom,h*zoom,rz)

	local scw,sch	= obj.screen_w,obj.screen_h



	-- work
	--   i摜j
	-------------------------

	obj.setoption("drawtarget","tempbuffer",w,h)
	obj.draw(0,0,0,zoom,1,0,0,rz)
	obj.load("tempbuffer")
	obj.rz	= 0

	local data,w,h	= obj.getpixeldata()
	local work	= obj.getpixeldata("work")

	-- work <- data
	hkmod.copypixeldata(work,data,w,h)



	-- data
	--   it[obt@j
	-------------------------

	obj.setoption("drawtarget","tempbuffer",w,h)
	obj.load("framebuffer")
	obj.draw(-x,-y)
	obj.load("tempbuffer")

	local data,w,h	= obj.getpixeldata()

	obj.rz		= 0
	obj.zoom	= 1/zoom

	return data,work,w,h

end

f_mode	= {
	hkmod.blend_Normal,		--  0.ʏ
	hkmod.blend_Add,		--  1.Z
	hkmod.blend_Sub,		--  2.Z
	hkmod.blend_Multiply,		--  3.Z
	hkmod.blend_Screen,		--  4.XN[
	hkmod.blend_Overlay,		--  5.I[o[C
	hkmod.blend_Lighten,		--  6.rij
	hkmod.blend_Darken,		--  7.riÁj
	hkmod.blend_Luminosity,		--  8.Px
	hkmod.blend_Color,		--  9.F
	hkmod.blend_LinearBurn,		-- 10.Ae	22.Ă jA
	hkmod.blend_LinearLight,	-- 11.	17.jACg
	hkmod.blend_Difference,		-- 12.
	hkmod.blend_Exclusion,		-- 13.O
	hkmod.blend_HardLight,		-- 14.n[hCg
	hkmod.blend_SoftLight,		-- 15.\tgCg
	hkmod.blend_VividLight,		-- 16.rrbhCg
	hkmod.blend_LinearLight,	-- 17.jACg
	hkmod.blend_PinLight,		-- 18.sCg
	hkmod.blend_ColorDodge,		-- 19.Ă J[
	hkmod.blend_LinearDodge,	-- 20.Ă jA
	hkmod.blend_ColorBurn,		-- 21.Ă J[
	hkmod.blend_LinearBurn,		-- 22.Ă jA
	hkmod.blend_Hue,		-- 23.Ae
	hkmod.blend_Saturation		-- 24.
}




